---
kind: DaemonSet
apiVersion: apps/v1
metadata:
  name: traefik-entrypoint
  namespace: {{.Values.namespace}}
  labels:
    app.kubernetes.io/name: traefik-entrypoint
spec:
  updateStrategy: 
    type: RollingUpdate
    rollingUpdate:
      maxUnavailable: 1
  selector:
    matchLabels:
      app.kubernetes.io/name: traefik-entrypoint
  template:
    metadata:
      labels:
        app.kubernetes.io/name: traefik-entrypoint
      annotations: 
        prometheus.io/scrape: 'true'
        prometheus.io/port: '8082'
    spec:
      serviceAccountName: traefik-entrypoint
      terminationGracePeriodSeconds: 60
      containers:
      - image: traefik
        name: traefik
        ports:
        - name: http
          containerPort: 80
          hostPort: 80
        - name: https
          containerPort: 443
          hostPort: 443
        - name: admin
          containerPort: 8080 
        livenessProbe:
          httpGet:
            path: /ping
            port: 80
          initialDelaySeconds: 5
          periodSeconds: 10
        readinessProbe:
          httpGet:
            path: /ping
            port: 80
          initialDelaySeconds: 5
          periodSeconds: 10
        args:
        - --api
        - --api.dashboard=true
        - --api.insecure=true
        - --entryPoints.web.address=:80
        - --entryPoints.web.forwardedHeaders.insecure
        - --entryPoints.websecure.address=:443
        - --ping=true
        - --ping.entryPoint=web
        - --providers.kubernetescrd=true
        - --providers.kubernetescrd.endpoint=https://kubernetes.default.svc
        - --metrics.prometheus=true
        - --entryPoints.metrics.address=:8082
        - --metrics.prometheus.entryPoint=metrics
        - --certificatesResolvers.acme-resolver.acme.email=benjamin.briet@protonmail.com
        - --certificatesResolvers.acme-resolver.acme.httpChallenge=true
        - --certificatesResolvers.acme-resolver.acme.httpChallenge.entryPoint=web
        - --certificatesResolvers.acme-resolver.acme.storage=acme.json
        - --log.level=DEBUG
